/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2005 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(AFX_POPUPTEXTURE_H__B67B692C_6626_4381_A330_138EF9041D56__INCLUDED_)
#define AFX_POPUPTEXTURE_H__B67B692C_6626_4381_A330_138EF9041D56__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef vector<COLORREF> ColorRefList;
typedef vector<COLORREF>::iterator ColorRefListIterator;

class PopupTexture  
{
public:
	PopupTexture();
	virtual ~PopupTexture();

	void configure(const string &uniquekey, const string &groupkey);
	void apply(HDC hDC, int x, int y, int width, int height);

	int getMinNeededHeight() { return (topEdge+bottomEdge); };

private:

	bool useAlphaMap;

	bool useSolidColors;

	void parseCFG(string cfg, COLORREF &bgcolor, COLORREF &lightcolor, COLORREF &darkcolor);
	void parseBevelCFG(string cfg, int &leftBevel, int &rightBevel, int &topBevel, int &bottomBevel );
	void solidGradientPaint(HDC destHDC, RECT r, bool vertical, int repeated);
	void paintEffects(HDC destHDC, int width, int height);

	void PrepareAlphaChannel(HBITMAP &bmp);

	HDC memoryDC;
	HBITMAP memoryBitmap;

	string solidColors;

	ColorRefList Gradient;

	int imageHeight;
	int imageWidth;

	int borderMethod;

	int leftEdge;
	int topEdge;
	int rightEdge;
	int bottomEdge;

	int mode;

	int popup_saturation;
	int popup_hueIntensity;
	COLORREF popup_hueColor;

	int bevelSizeLeft, bevelSizeRight, bevelSizeTop, bevelSizeBottom;
	bool verticalGradient;
	int  repeatedGradient;
	COLORREF backgroundColor;
	COLORREF darkBevelColor;
	COLORREF lightBevelColor;
};

#endif // !defined(AFX_POPUPTEXTURE_H__B67B692C_6626_4381_A330_138EF9041D56__INCLUDED_)
